<?php
namespace Indeterminado\Repositories;

class Ajustmapaapursg extends \Doctrine\ORM\EntityRepository
{
    public function somaValoresPorTipoAjuste($mapa, $pais, $estado, $tipoAjuste, $valor, $organizacao)
    {
        try {
            $sql = <<<SQL
              SELECT
                NVL(SUM (VRAJUSTEAPURSG), 0)
              FROM AJUSTMAPAAPURSG
              WHERE NRSEQUMAPAPU    = :P_NRSEQUMAPAPU
                AND CDPAIS          = :P_CDPAIS
                AND SGESTADO        = :P_SGESTADO
                AND IDTPAJUSTEAPSG  = :P_IDTPAJUSTEAPSG
                AND NRORG           = :P_NRORG
SQL;
            $params = array(
                'P_NRSEQUMAPAPU'    => $mapa,
                'P_CDPAIS'          => $pais,
                'P_SGESTADO'        => $estado,
                'P_IDTPAJUSTEAPSG'  => $tipoAjuste,
                'P_VALOR'           => $valor,
                'P_NRORG'           => $organizacao,
            );

            return \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchArray($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function dataSetOutrosValoresGuiaArrecadacao($mapa, $pais, $estado, $organizacao)
    {
        try {
            $sql = <<<SQL
              SELECT IDATIVO,
                NRSEQUMAPAPU,
                CDPAIS,
                SGESTADO,
                NRSEQAJUSAPURSG,
                DSAJUSTEAPURSG,
                VRAJUSTEAPURSG,
                CDAJUSTEAPURSG,
                IDTPAJUSTEAPSG,
                NRORG,
                NRORGINCLUSAO,
                NRORGULTATU,
                DTINCLUSAO,
                DTULTATU,
                CDOPERINCLUSAO,
                CDOPERULTATU
              FROM AJUSTMAPAAPURSG
              WHERE NRSEQUMAPAPU  = :P_NRSEQUMAPAPU
                AND CDPAIS        = :P_CDPAIS
                AND SGESTADO      = :P_SGESTADO
                AND NRORG         = :P_NRORG
              ORDER BY NRSEQAJUSAPURSG
SQL;
            $params = array(
                'P_NRSEQUMAPAPU'    => $mapa,
                'P_CDPAIS'          => $pais,
                'P_SGESTADO'        => $estado,
                'P_NRORG'           => $organizacao,
            );

            return \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}